------------------------------------------------------------------------------------------
-- UIShowSearch file
-- Written by Homeopatix
-- 26 january 2021
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-- create the bag window
------------------------------------------------------------------------------------------
function CreateUiSearch(textToSearch, where)

	local nbrItemInBag = 0;
	local windowHeightSize = 0;
	local windowWidth = 0;

	windowWidth = 400;
	if(textToSearch == nil)then
		textToSearch = "**";
	end

	nbrItemInBag = ReturnNbrItemsInBag(textToSearch);
	nbrItemInBag = nbrItemInBag + ReturnNbrItemsInVault(textToSearch);
	nbrItemInBag = nbrItemInBag + ReturnNbrItemsInSharedStorage(textToSearch);

	UIShowSearch=Turbine.UI.Lotro.GoldWindow(); 
	UIShowSearch:SetSize(windowWidth, 650 + 70); 
	UIShowSearch:SetText( Strings.PluginSearch ); 
	UIShowSearch:SetPosition((Turbine.UI.Display:GetWidth()-UIShowSearch:GetWidth())/2,(Turbine.UI.Display:GetHeight()-UIShowSearch:GetHeight())/2); 

	UIShowSearch.Message=Turbine.UI.Label(); 
	UIShowSearch.Message:SetParent(UIShowSearch); 
	UIShowSearch.Message:SetSize(150,10); 
	UIShowSearch.Message:SetPosition(UIShowSearch:GetWidth()/2 - 75, UIShowSearch:GetHeight() - 20); 
	UIShowSearch.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
	UIShowSearch.Message:SetText(Strings.PluginText); 
	UIShowSearch:SetZOrder(10);
	UIShowSearch:SetWantsKeyEvents(true);
	UIShowSearch:SetVisible(false);

	textBoxLines = Turbine.UI.Lotro.TextBox();
	textBoxLines:SetParent( UIShowSearch );
	textBoxLines:SetSize(300, 30); 
	textBoxLines:SetText( "" ); 
	textBoxLines:SetPosition(UIShowSearch:GetWidth()/2 - 150, 50);
	textBoxLines:SetVisible(true);
	textBoxLines:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
	textBoxLines:SetForeColor( Turbine.UI.Color.Gold);
	textBoxLines:SetBackColor( Turbine.UI.Color( .9, .5, .7, .5));

	UIShowSearch.Message=Turbine.UI.Label(); 
	UIShowSearch.Message:SetParent(UIShowSearch); 
	UIShowSearch.Message:SetSize(380,20); 
	UIShowSearch.Message:SetPosition(UIShowSearch:GetWidth()/2 - 190, 90);
	UIShowSearch.Message:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19);
	UIShowSearch.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
	UIShowSearch.Message:SetText(Strings.PluginSearch9); 
	------------------------------------------------------------------------------------------
	-- buttons de recherche
	------------------------------------------------------------------------------------------
	buttonSearch = Turbine.UI.Lotro.GoldButton();
	buttonSearch:SetParent( UIShowSearch );
	buttonSearch:SetPosition(UIShowSearch:GetWidth()/2 - 125, 160);
	buttonSearch:SetSize( 300, 20 );
	buttonSearch:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	buttonSearch:SetText( Strings.PluginSearch8 );
	buttonSearch:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	buttonSearch:SetVisible(true);
	buttonSearch:SetMouseVisible(true);

	buttonSearchBag = Turbine.UI.Lotro.GoldButton();
	buttonSearchBag:SetParent( UIShowSearch );
	buttonSearchBag:SetPosition(UIShowSearch:GetWidth() - UIShowSearch:GetWidth() + 50, 110);
	buttonSearchBag:SetSize( 150, 20 );
	buttonSearchBag:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	buttonSearchBag:SetText( Strings.PluginSearch3 );
	buttonSearchBag:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	buttonSearchBag:SetVisible(true);
	buttonSearchBag:SetMouseVisible(true);

	buttonSearchVault = Turbine.UI.Lotro.GoldButton();
	buttonSearchVault:SetParent( UIShowSearch );
	buttonSearchVault:SetPosition(UIShowSearch:GetWidth() - 200, 110);
	buttonSearchVault:SetSize( 150, 20 );
	buttonSearchVault:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	buttonSearchVault:SetText( Strings.PluginSearch4 );
	buttonSearchVault:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	buttonSearchVault:SetVisible(true);
	buttonSearchVault:SetMouseVisible(true);

	buttonSearchWallet = Turbine.UI.Lotro.GoldButton();
	buttonSearchWallet:SetParent( UIShowSearch );
	buttonSearchWallet:SetPosition(UIShowSearch:GetWidth() - UIShowSearch:GetWidth() + 50, 135);
	buttonSearchWallet:SetSize( 150, 20 );
	buttonSearchWallet:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	buttonSearchWallet:SetText( Strings.PluginSearch7 );
	buttonSearchWallet:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	buttonSearchWallet:SetVisible(true);
	buttonSearchWallet:SetMouseVisible(true);

	buttonSearchShared = Turbine.UI.Lotro.GoldButton();
	buttonSearchShared:SetParent( UIShowSearch );
	buttonSearchShared:SetPosition(UIShowSearch:GetWidth() - 200, 135);
	buttonSearchShared:SetSize( 150, 20 );
	buttonSearchShared:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	buttonSearchShared:SetText( Strings.PluginSearch5 );
	buttonSearchShared:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	buttonSearchShared:SetVisible(true);
	buttonSearchShared:SetMouseVisible(true);

	------------------------------------------------------------------------------------------
	-- mouse click handler for search button
	------------------------------------------------------------------------------------------
	buttonSearch.MouseClick = function(sender, args)
		local textToSearch = textBoxLines:GetText();
		if(string.len(textToSearch) >= 2)then
			CreateUiSearch(textToSearch, nil);
			UIShowSearch:SetVisible(true);
		end
	end

	buttonSearchBag.MouseClick = function(sender, args)
		local textToSearch = textBoxLines:GetText();
		if(string.len(textToSearch) >= 2)then
			CreateUiSearch(textToSearch, "bag");
			UIShowSearch:SetVisible(true);
		end
	end

	buttonSearchVault.MouseClick = function(sender, args)
		local textToSearch = textBoxLines:GetText();
		if(string.len(textToSearch) >= 2)then
			CreateUiSearch(textToSearch, "vault");
			UIShowSearch:SetVisible(true);
		end
	end

	buttonSearchWallet.MouseClick = function(sender, args)
		local textToSearch = textBoxLines:GetText();
		if(string.len(textToSearch) >= 2)then
			CreateUiSearch(textToSearch, "wallet");
			UIShowSearch:SetVisible(true);
		end
	end

	buttonSearchShared.MouseClick = function(sender, args)
		local textToSearch = textBoxLines:GetText();
		if(string.len(textToSearch) >= 2)then
			CreateUiSearch(textToSearch, "shared");
			UIShowSearch:SetVisible(true);
		end
	end
	------------------------------------------------------------------------------------------
	--- button help
	------------------------------------------------------------------------------------------
	buttonDefineHelp = Turbine.UI.Extensions.SimpleWindow();
	buttonDefineHelp:SetParent( UIShowSearch );
	buttonDefineHelp:SetPosition(windowWidth - 40, 140);
	buttonDefineHelp:SetSize( 20, 20 );
	buttonDefineHelp:SetVisible(true);
	buttonDefineHelp:SetMouseVisible(true);

	centerLabelHelp = Turbine.UI.Label();
	centerLabelHelp:SetParent(buttonDefineHelp);
	centerLabelHelp:SetPosition( 0, 0 );
	centerLabelHelp:SetSize( 20, 20  );
	centerLabelHelp:SetBackground(ResourcePath .. "Help.tga");
	centerLabelHelp:SetZOrder(-1);
	centerLabelHelp:SetMouseVisible(false);

	helpButtonLabel = Turbine.UI.Extensions.SimpleWindow();
	helpButtonLabel:SetParent( UIShowSearch );
	helpButtonLabel:SetPosition (windowWidth - 20, 130);
	helpButtonLabel:SetSize( 180, 30 );
	helpButtonLabel:SetZOrder(10000);
	helpButtonLabel:SetVisible(false);
	helpButtonLabel:SetBackground(ResourcePath .. "/Cadre_180_30.tga");

	centerLabelBLabelHelp = Turbine.UI.Label();
	centerLabelBLabelHelp:SetParent(helpButtonLabel);
	centerLabelBLabelHelp:SetPosition( 2, 2 );
	centerLabelBLabelHelp:SetSize( 176, 26  );
	centerLabelBLabelHelp:SetText( Strings.PluginLabelHelp );
	centerLabelBLabelHelp:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	centerLabelBLabelHelp:SetBackColor( Turbine.UI.Color( .9, .1, .4, .9) );
	centerLabelBLabelHelp:SetZOrder(-1);

	buttonDefineHelp.MouseEnter = function()
		helpButtonLabel:SetVisible(true);
	end

	buttonDefineHelp.MouseLeave = function()
		helpButtonLabel:SetVisible(false);
	end

	buttonDefineHelp.MouseClick = function(sender, args)
		GenerateHelpWindow();
		HelpWindow:SetVisible(true);
	end

	buttonClose = Turbine.UI.Lotro.GoldButton();
	buttonClose:SetParent( UIShowSearch );
	buttonClose:SetPosition(UIShowSearch:GetWidth()/2 - 125, UIShowSearch:GetHeight() - 50);
	buttonClose:SetSize( 300, 20 );
	buttonClose:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	buttonClose:SetText( Strings.PluginCloseButton );
	buttonClose:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	buttonClose:SetVisible(true);
	buttonClose:SetMouseVisible(true);

	buttonClose.MouseClick = function(sender, args)
		settings["isSearchWindowVisible"]["isSearchWindowVisible"] = false;
		UIShowSearch:SetVisible(false);
	end

	centerWindow = {};
	centerWindowName = {};
	------------------------------------------------------------------------------------------
	-- create the viewport control all it needs is size and position as it is simply used to create viewable bounds for our map
	------------------------------------------------------------------------------------------
	viewport1=Turbine.UI.Control();
	viewport1:SetParent(UIShowSearch);
	viewport1:SetSize(windowWidth-35, 450);
	viewport1:SetPosition(10, 190);
	------------------------------------------------------------------------------------------
	-- create the map content for our viewport, again, it only needs size and position as it is just a container for the grid of images
	------------------------------------------------------------------------------------------
	viewport1.map=Turbine.UI.Control();
	------------------------------------------------------------------------------------------
	viewport1.map:SetParent(viewport1); -- set the map as a child of the viewport so that it will be bounded by it for drawing purposes
	-- we'll use a 5x4 grid but this obviously could be expanded, or even set up as a recycled array of controls
	------------------------------------------------------------------------------------------
	heightSizeOfMap = 0;
	tmpItemsCount = 0;
	datasFromSearch = {};
	local tmpSearchGlobal = 0;

	if(where == "bag" or where == nil)then
		datasFromSearch[1], datasFromSearch[2] = ReturnNbrItemsInBag(textToSearch);
		heightSizeOfMap = heightSizeOfMap + (datasFromSearch[1] * 38);
		heightSizeOfMap = heightSizeOfMap + (datasFromSearch[2] * 40);
		heightSizeOfMap = heightSizeOfMap + 20;
		tmpItemsCount = tmpItemsCount + datasFromSearch[1];
		tmpSearchGlobal = tmpSearchGlobal + 1;
	end
	if(where == "vault" or where == nil)then
		datasFromSearch[1], datasFromSearch[2] = ReturnNbrItemsInVault(textToSearch);
		heightSizeOfMap = heightSizeOfMap + (datasFromSearch[1] * 38);
		heightSizeOfMap = heightSizeOfMap + (datasFromSearch[2] * 40);
		heightSizeOfMap = heightSizeOfMap + 20;
		tmpItemsCount = tmpItemsCount + datasFromSearch[1];
		tmpSearchGlobal = tmpSearchGlobal + 1;
	end
	if(where == "wallet" or where == nil)then
		datasFromSearch[1], datasFromSearch[2] = ReturnNbrItemsInWallet(textToSearch);
		heightSizeOfMap = heightSizeOfMap + (datasFromSearch[1] * 38);
		heightSizeOfMap = heightSizeOfMap + (datasFromSearch[2] * 40);
		heightSizeOfMap = heightSizeOfMap + 20;
		tmpItemsCount = tmpItemsCount + datasFromSearch[1];
		tmpSearchGlobal = tmpSearchGlobal + 1;
	end
	if(where == "shared" or where == nil)then
		datasFromSearch[1], datasFromSearch[2] = ReturnNbrItemsInSharedStorage(textToSearch);
		heightSizeOfMap = heightSizeOfMap + (datasFromSearch[1] * 38);
		heightSizeOfMap = heightSizeOfMap + 30;
		tmpItemsCount = tmpItemsCount + datasFromSearch[1];
		tmpSearchGlobal = tmpSearchGlobal + 1;
	end

	if(tmpSearchGlobal == 4)then
		heightSizeOfMap = heightSizeOfMap + 10;
	end

	viewport1.map:SetSize(windowWidth-55, heightSizeOfMap); 
	------------------------------------------------------------------------------------------
	viewport1.map:SetPosition(0,0); -- we'll start off in the upper left
	------------------------------------------------------------------------------------------

	local posx = 10;
	local posy = 20;
	local nameDisplayed = false;

	if(where == "bag" or where == nil)then
			------------------------------------------------------------------------------------------
			-- search bag
			------------------------------------------------------------------------------------------
			posy = posy - 10;

			if(textToSearch == nil or ReturnNbrItemsInBag(textToSearch) <= 0)then
				-- do nothing
			else
				LabelName=Turbine.UI.Label(); 
				LabelName:SetParent(viewport1.map); 
				LabelName:SetSize(windowWidth - 35, 20); 
				LabelName:SetPosition(10, 0); 
				LabelName:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22);
				LabelName:SetForeColor(Turbine.UI.Color.White);
				LabelName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
				LabelName:SetText( Strings.PluginSearch3 ); 
				LabelName:SetVisible(true);
				LabelName:SetBackColor(Turbine.UI.Color( .8, .5, .6, .5)); -- just to give it a little style
			end

			posy = posy + 10;

			if(textToSearch == nil)then
				-- do nothing
			else
				for namePlayerToshow in pairs(PlayerBags) do
					for i in pairs(PlayerBags[namePlayerToshow]) do
						if(string.find(PlayerBags[namePlayerToshow][i].N, textToSearch) ~= nil)then
							--Turbine.Shell.WriteLine("bag of : " .. namePlayerToshow .. " : " .. textToSearch .. " Trouver dans le slot : " .. slot);

							if(nameDisplayed == false)then
								LabelName=Turbine.UI.Label(); 
								LabelName:SetParent(viewport1.map); 
								LabelName:SetSize(350,40); 
								LabelName:SetPosition(posx, posy); 
								LabelName:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold24);
								LabelName:SetForeColor(Turbine.UI.Color.Gold);
								LabelName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft); 
								LabelName:SetText( namePlayerToshow ); 
								LabelName:SetVisible(true);
								--LabelName:SetBackColor(Turbine.UI.Color.Red); -- just to give it a little style

								nameDisplayed = true;
								posy = posy + 40;
							end

							centerWindow[i] = Turbine.UI.Control();
							centerWindow[i]:SetSize( 32 , 32 );
							centerWindow[i]:SetParent( viewport1.map );
							centerWindow[i]:SetPosition( posx, posy);
							centerWindow[i]:SetVisible( true );
							centerWindow[i]:SetBackground(0x41000001); -- fond grey
							--centerWindow[i]:SetBackColor( Turbine.UI.Color( .9, .5, .7, .5) );

							centerWindowName[i] = Turbine.UI.Control();
							centerWindowName[i]:SetSize( 300 , 32 );
							centerWindowName[i]:SetParent( viewport1.map );
							centerWindowName[i]:SetPosition( posx + 45, posy);
							centerWindowName[i]:SetVisible( true );
							centerWindowName[i]:SetBackColor( Turbine.UI.Color( 0.9, 0.3, 0.3, 0.3 ) );

							itemTmp = Turbine.UI.Control();
							centerWindow[i].itemTmp = itemTmp;
							itemTmp:SetParent( centerWindow[i] );
							itemTmp:SetSize( 32, 32 );
							itemTmp:SetPosition( 1, 1 );
							itemTmp:SetZOrder(centerWindow[i]:GetZOrder() + 1);
							itemTmp:SetBackground(tonumber(PlayerBags[namePlayerToshow][tostring(i)].Q));
							itemTmp:SetBlendMode( Turbine.UI.BlendMode.Overlay );
							itemTmp:SetVisible( true );
							itemTmp:SetMouseVisible( true );

							itemTmp1 = Turbine.UI.Control();
							itemTmp1:SetParent( centerWindow[i] );
							itemTmp1:SetSize( 32, 32 );
							itemTmp1:SetPosition( 1, 1 );
							itemTmp1:SetZOrder(centerWindow[i]:GetZOrder() + 1);
							itemTmp1:SetBackground(tonumber(PlayerBags[namePlayerToshow][tostring(i)].B));
							itemTmp1:SetBlendMode( Turbine.UI.BlendMode.Overlay );
							itemTmp1:SetVisible( true );

							itemTmp3 = Turbine.UI.Control();
							itemTmp3:SetParent( centerWindow[i] );
							itemTmp3:SetSize( 32, 32 );
							itemTmp3:SetPosition( 1, 1 );
							itemTmp3:SetZOrder(centerWindow[i]:GetZOrder() + 1);
							if(tonumber(PlayerBags[namePlayerToshow][tostring(i)].S) == 0)then
								if(tonumber(PlayerBags[namePlayerToshow][tostring(i)].QA) == 1)then
									itemTmp3:SetBackground(0x410030C4);
								end
								if(tonumber(PlayerBags[namePlayerToshow][tostring(i)].QA) == 2)then
									itemTmp3:SetBackground(0x410030C4);
								end
								if(tonumber(PlayerBags[namePlayerToshow][tostring(i)].QA) == 3)then
									itemTmp3:SetBackground(0x410030C4);
								end
								if(tonumber(PlayerBags[namePlayerToshow][tostring(i)].QA) == 4)then
									itemTmp3:SetBackground(0x410030C4);
								end
								if(tonumber(PlayerBags[namePlayerToshow][tostring(i)].QA) == 5)then
									itemTmp3:SetBackground(0x410030C4);
								end
							else
								itemTmp3:SetBackground(tonumber(PlayerBags[namePlayerToshow][tostring(i)].S));
							end
							itemTmp3:SetBlendMode( Turbine.UI.BlendMode.Overlay );
							itemTmp3:SetVisible( true );

							itemTmp4 = Turbine.UI.Control();
							itemTmp4:SetParent( centerWindow[i] );
							itemTmp4:SetSize( 32, 32 );
							itemTmp4:SetPosition( 1, 1 );
							itemTmp4:SetZOrder(centerWindow[i]:GetZOrder() + 1);
							itemTmp4:SetBackground(tonumber(PlayerBags[namePlayerToshow][tostring(i)].I));
							itemTmp4:SetBlendMode( Turbine.UI.BlendMode.Overlay );
							itemTmp4:SetVisible( true );

							UIShowSearch.Message=Turbine.UI.Label(); 
							UIShowSearch.Message:SetParent(centerWindowName[i]); 
							UIShowSearch.Message:SetSize(300, 32); 
							UIShowSearch.Message:SetPosition( 1, 1); 
							UIShowSearch.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft); 
							UIShowSearch.Message:SetText(rgb["gold"] .. PlayerBags[namePlayerToshow][tostring(i)].QUA .. rgb["clear"] .. " " .. PlayerBags[namePlayerToshow][tostring(i)].N); 
							UIShowSearch.Message:SetBackColor(Turbine.UI.Color( 0.9, 0.3, 0.3, 0.3 ));
							UIShowSearch.Message:SetMarkupEnabled(true);	

							posy = posy + 38;
						end
					end
					nameDisplayed = false;
				end
			end
			posy = posy + 20;	
	end

	if(where == "vault" or where == nil)then
		------------------------------------------------------------------------------------------
		-- search vault
		------------------------------------------------------------------------------------------
		posy = posy - 10;

		if(textToSearch == nil or ReturnNbrItemsInVault(textToSearch) <= 0)then
			-- do nothing
		else
			LabelName=Turbine.UI.Label(); 
			LabelName:SetParent(viewport1.map); 
			LabelName:SetSize(windowWidth - 35, 20); 
			LabelName:SetPosition(posx, posy - 10); 
			LabelName:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22);
			LabelName:SetForeColor(Turbine.UI.Color.White);
			LabelName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
			LabelName:SetText( Strings.PluginSearch4 ); 
			LabelName:SetVisible(true);
			LabelName:SetBackColor(Turbine.UI.Color( .8, .5, .6, .5)); -- just to give it a little style
		end
		posy = posy + 10;

		if(textToSearch == nil)then
			-- do nothing
		else
			for namePlayerToshow in pairs(PlayerVault) do
				for i in pairs(PlayerVault[namePlayerToshow]) do
					if(string.find(PlayerVault[namePlayerToshow][i].N, textToSearch) ~= nil)then
						--Turbine.Shell.WriteLine("bag of : " .. namePlayerToshow .. " : " .. textToSearch .. " Trouver dans le slot : " .. slot);

						if(nameDisplayed == false)then
							LabelName=Turbine.UI.Label(); 
							LabelName:SetParent(viewport1.map); 
							LabelName:SetSize(350,40); 
							LabelName:SetPosition(posx, posy); 
							LabelName:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold24);
							LabelName:SetForeColor(Turbine.UI.Color.Gold);
							LabelName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft); 
							LabelName:SetText( namePlayerToshow ); 
							LabelName:SetVisible(true);
							--LabelName:SetBackColor(Turbine.UI.Color.Red); -- just to give it a little style

							nameDisplayed = true;
							posy = posy + 40;
						end

						centerWindow[i] = Turbine.UI.Control();
						centerWindow[i]:SetSize( 32 , 32 );
						centerWindow[i]:SetParent( viewport1.map );
						centerWindow[i]:SetPosition( posx, posy);
						centerWindow[i]:SetVisible( true );
						centerWindow[i]:SetBackground(0x41000001); -- fond grey
						--centerWindow[i]:SetBackColor( Turbine.UI.Color( .9, .5, .7, .5) );

						centerWindowName[i] = Turbine.UI.Control();
						centerWindowName[i]:SetSize( 300 , 32 );
						centerWindowName[i]:SetParent( viewport1.map );
						centerWindowName[i]:SetPosition( posx + 45, posy);
						centerWindowName[i]:SetVisible( true );
						centerWindowName[i]:SetBackColor( Turbine.UI.Color( 0.9, 0.3, 0.3, 0.3 ) );

						itemTmp = Turbine.UI.Control();
						centerWindow[i].itemTmp = itemTmp;
						itemTmp:SetParent( centerWindow[i] );
						itemTmp:SetSize( 32, 32 );
						itemTmp:SetPosition( 1, 1 );
						itemTmp:SetZOrder(centerWindow[i]:GetZOrder() + 1);
						itemTmp:SetBackground(tonumber(PlayerVault[namePlayerToshow][tostring(i)].Q));
						itemTmp:SetBlendMode( Turbine.UI.BlendMode.Overlay );
						itemTmp:SetVisible( true );
						itemTmp:SetMouseVisible( true );

						itemTmp1 = Turbine.UI.Control();
						itemTmp1:SetParent( centerWindow[i] );
						itemTmp1:SetSize( 32, 32 );
						itemTmp1:SetPosition( 1, 1 );
						itemTmp1:SetZOrder(centerWindow[i]:GetZOrder() + 1);
						itemTmp1:SetBackground(tonumber(PlayerVault[namePlayerToshow][tostring(i)].B));
						itemTmp1:SetBlendMode( Turbine.UI.BlendMode.Overlay );
						itemTmp1:SetVisible( true );

						itemTmp3 = Turbine.UI.Control();
						itemTmp3:SetParent( centerWindow[i] );
						itemTmp3:SetSize( 32, 32 );
						itemTmp3:SetPosition( 1, 1 );
						itemTmp3:SetZOrder(centerWindow[i]:GetZOrder() + 1);
						if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].S) == 0)then
							if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].QA) == 1)then
								itemTmp3:SetBackground(0x410030C4);
							end
							if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].QA) == 2)then
								itemTmp3:SetBackground(0x410030C4);
							end
							if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].QA) == 3)then
								itemTmp3:SetBackground(0x410030C4);
							end
							if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].QA) == 4)then
								itemTmp3:SetBackground(0x410030C4);
							end
							if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].QA) == 5)then
								itemTmp3:SetBackground(0x410030C4);
							end
						else
							itemTmp3:SetBackground(tonumber(PlayerVault[namePlayerToshow][tostring(i)].S));
						end
						itemTmp3:SetBlendMode( Turbine.UI.BlendMode.Overlay );
						itemTmp3:SetVisible( true );

						itemTmp4 = Turbine.UI.Control();
						itemTmp4:SetParent( centerWindow[i] );
						itemTmp4:SetSize( 32, 32 );
						itemTmp4:SetPosition( 1, 1 );
						itemTmp4:SetZOrder(centerWindow[i]:GetZOrder() + 1);
						itemTmp4:SetBackground(tonumber(PlayerVault[namePlayerToshow][tostring(i)].I));
						itemTmp4:SetBlendMode( Turbine.UI.BlendMode.Overlay );
						itemTmp4:SetVisible( true );

						UIShowSearch.Message=Turbine.UI.Label(); 
						UIShowSearch.Message:SetParent(centerWindowName[i]); 
						UIShowSearch.Message:SetSize(300, 32); 
						UIShowSearch.Message:SetPosition( 1, 1); 
						UIShowSearch.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft); 
						UIShowSearch.Message:SetText(rgb["gold"] .. PlayerVault[namePlayerToshow][tostring(i)].QUA .. rgb["clear"] .. " " .. PlayerVault[namePlayerToshow][tostring(i)].N); 
						UIShowSearch.Message:SetBackColor(Turbine.UI.Color( 0.9, 0.3, 0.3, 0.3 ));
						UIShowSearch.Message:SetMarkupEnabled(true);	

						posy = posy + 38;
					end
				end
				nameDisplayed = false;
			end
		end
		posy = posy + 20;
	end

	if(where == "wallet" or where == nil)then
		------------------------------------------------------------------------------------------
		-- search wallet 
		------------------------------------------------------------------------------------------
		posy = posy - 10;

		if(textToSearch == nil or ReturnNbrItemsInWallet(textToSearch) <= 0)then
			-- do nothing
		else
			LabelName=Turbine.UI.Label(); 
			LabelName:SetParent(viewport1.map); 
			LabelName:SetSize(windowWidth - 35, 20); 
			LabelName:SetPosition(posx, posy - 10); 
			LabelName:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22);
			LabelName:SetForeColor(Turbine.UI.Color.White);
			LabelName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
			LabelName:SetText( Strings.PluginSearch7 ); 
			LabelName:SetVisible(true);
			LabelName:SetBackColor(Turbine.UI.Color( .8, .5, .6, .5)); -- just to give it a little style
		end
		posy = posy + 10;

		if(textToSearch == nil)then
			-- do nothing
		else
			for namePlayerToshow in pairs(PlayerWallet) do
				for i in pairs(PlayerWallet[namePlayerToshow]) do
					if(string.find(PlayerWallet[namePlayerToshow][i].N, textToSearch) ~= nil)then
						--Turbine.Shell.WriteLine("bag of : " .. namePlayerToshow .. " : " .. textToSearch .. " Trouver dans le slot : " .. slot);

						if(nameDisplayed == false)then
							LabelName=Turbine.UI.Label(); 
							LabelName:SetParent(viewport1.map); 
							LabelName:SetSize(350,40); 
							LabelName:SetPosition(posx, posy); 
							LabelName:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold24);
							LabelName:SetForeColor(Turbine.UI.Color.Gold);
							LabelName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft); 
							LabelName:SetText( namePlayerToshow ); 
							LabelName:SetVisible(true);
							--LabelName:SetBackColor(Turbine.UI.Color.Red); -- just to give it a little style

							nameDisplayed = true;
							posy = posy + 40;
						end

						centerWindow[i] = Turbine.UI.Control();
						centerWindow[i]:SetSize( 32 , 32 );
						centerWindow[i]:SetParent( viewport1.map );
						centerWindow[i]:SetPosition( posx, posy);
						centerWindow[i]:SetVisible( true );
						centerWindow[i]:SetBackground(0x41000001); -- fond grey
						--centerWindow[i]:SetBackColor( Turbine.UI.Color( .9, .5, .7, .5) );

						centerWindowName[i] = Turbine.UI.Control();
						centerWindowName[i]:SetSize( 300 , 32 );
						centerWindowName[i]:SetParent( viewport1.map );
						centerWindowName[i]:SetPosition( posx + 45, posy);
						centerWindowName[i]:SetVisible( true );
						centerWindowName[i]:SetBackColor( Turbine.UI.Color( 0.9, 0.3, 0.3, 0.3 ) );

						itemTmp = Turbine.UI.Control();
						centerWindow[i].itemTmp = itemTmp;
						itemTmp:SetParent( centerWindow[i] );
						itemTmp:SetSize( 32, 32 );
						itemTmp:SetPosition( 1, 1 );
						itemTmp:SetZOrder(centerWindow[i]:GetZOrder() + 1);
						itemTmp:SetBackground(tonumber(PlayerWallet[namePlayerToshow][tostring(i)].Q));
						itemTmp:SetBlendMode( Turbine.UI.BlendMode.Overlay );
						itemTmp:SetVisible( true );
						itemTmp:SetMouseVisible( true );

						itemTmp1 = Turbine.UI.Control();
						itemTmp1:SetParent( centerWindow[i] );
						itemTmp1:SetSize( 32, 32 );
						itemTmp1:SetPosition( 1, 1 );
						itemTmp1:SetZOrder(centerWindow[i]:GetZOrder() + 1);
						itemTmp1:SetBackground(tonumber(PlayerWallet[namePlayerToshow][tostring(i)].B));
						itemTmp1:SetBlendMode( Turbine.UI.BlendMode.Overlay );
						itemTmp1:SetVisible( true );

						itemTmp3 = Turbine.UI.Control();
						itemTmp3:SetParent( centerWindow[i] );
						itemTmp3:SetSize( 32, 32 );
						itemTmp3:SetPosition( 1, 1 );
						itemTmp3:SetZOrder(centerWindow[i]:GetZOrder() + 1);
						if(tonumber(PlayerWallet[namePlayerToshow][tostring(i)].S) == 0)then
							if(tonumber(PlayerWallet[namePlayerToshow][tostring(i)].QA) == 1)then
								itemTmp3:SetBackground(0x410030C4);
							end
							if(tonumber(PlayerWallet[namePlayerToshow][tostring(i)].QA) == 2)then
								itemTmp3:SetBackground(0x410030C4);
							end
							if(tonumber(PlayerWallet[namePlayerToshow][tostring(i)].QA) == 3)then
								itemTmp3:SetBackground(0x410030C4);
							end
							if(tonumber(PlayerWallet[namePlayerToshow][tostring(i)].QA) == 4)then
								itemTmp3:SetBackground(0x410030C4);
							end
							if(tonumber(PlayerWallet[namePlayerToshow][tostring(i)].QA) == 5)then
								itemTmp3:SetBackground(0x410030C4);
							end
						else
							itemTmp3:SetBackground(tonumber(PlayerWallet[namePlayerToshow][tostring(i)].S));
						end
						itemTmp3:SetBlendMode( Turbine.UI.BlendMode.Overlay );
						itemTmp3:SetVisible( true );

						itemTmp4 = Turbine.UI.Control();
						itemTmp4:SetParent( centerWindow[i] );
						itemTmp4:SetSize( 32, 32 );
						itemTmp4:SetPosition( 1, 1 );
						itemTmp4:SetZOrder(centerWindow[i]:GetZOrder() + 1);
						itemTmp4:SetBackground(tonumber(PlayerWallet[namePlayerToshow][tostring(i)].I));
						itemTmp4:SetBlendMode( Turbine.UI.BlendMode.Overlay );
						itemTmp4:SetVisible( true );

						UIShowSearch.Message=Turbine.UI.Label(); 
						UIShowSearch.Message:SetParent(centerWindowName[i]); 
						UIShowSearch.Message:SetSize(300, 32); 
						UIShowSearch.Message:SetPosition( 1, 1); 
						UIShowSearch.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft); 
						UIShowSearch.Message:SetText(rgb["gold"] .. PlayerWallet[namePlayerToshow][tostring(i)].QUA .. rgb["clear"] .. " " .. PlayerWallet[namePlayerToshow][tostring(i)].N); 
						UIShowSearch.Message:SetBackColor(Turbine.UI.Color( 0.9, 0.3, 0.3, 0.3 ));
						UIShowSearch.Message:SetMarkupEnabled(true);	

						posy = posy + 38;
					end
				end
				nameDisplayed = false;
			end
			nameDisplayed = false;
		end

		posy = posy + 20;
	end

	if(where == "shared" or where == nil)then
		------------------------------------------------------------------------------------------
		-- search shared storage
		------------------------------------------------------------------------------------------
		posy = posy - 10;

		if(textToSearch == nil or ReturnNbrItemsInSharedStorage(textToSearch) <= 0)then
			-- do nothing
		else
			LabelName=Turbine.UI.Label(); 
			LabelName:SetParent(viewport1.map); 
			LabelName:SetSize(windowWidth - 35, 20); 
			LabelName:SetPosition(posx, posy - 10); 
			LabelName:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22);
			LabelName:SetForeColor(Turbine.UI.Color.White);
			LabelName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
			LabelName:SetText( Strings.PluginSearch5 ); 
			LabelName:SetVisible(true);
			LabelName:SetBackColor(Turbine.UI.Color( .8, .5, .6, .5)); -- just to give it a little style
		end

		posy = posy + 10;

		nbrItemInSharedSrorage = 0;

		for i in pairs(SharedStorageVault) do
				nbrItemInSharedSrorage = nbrItemInSharedSrorage + 1 ;
		end
		posy = posy + 10;

		if(textToSearch == nil)then
			-- do nothing
		else
				for i=1, nbrItemInSharedSrorage do  
					if(string.find(SharedStorageVault[tostring(i)].N, textToSearch) ~= nil)then
						--Turbine.Shell.WriteLine("bag of : " .. namePlayerToshow .. " : " .. textToSearch .. " Trouver dans le slot : " .. slot);

						centerWindow[i] = Turbine.UI.Control();
						centerWindow[i]:SetSize( 32 , 32 );
						centerWindow[i]:SetParent( viewport1.map );
						centerWindow[i]:SetPosition( posx, posy);
						centerWindow[i]:SetVisible( true );
						centerWindow[i]:SetBackground(0x41000001); -- fond grey
						--centerWindow[i]:SetBackColor( Turbine.UI.Color( .9, .5, .7, .5) );

						centerWindowName[i] = Turbine.UI.Control();
						centerWindowName[i]:SetSize( 300 , 32 );
						centerWindowName[i]:SetParent( viewport1.map );
						centerWindowName[i]:SetPosition( posx + 45, posy);
						centerWindowName[i]:SetVisible( true );
						centerWindowName[i]:SetBackColor( Turbine.UI.Color( 0.9, 0.3, 0.3, 0.3 ) );

						itemTmp = Turbine.UI.Control();
						centerWindow[i].itemTmp = itemTmp;
						itemTmp:SetParent( centerWindow[i] );
						itemTmp:SetSize( 32, 32 );
						itemTmp:SetPosition( 1, 1 );
						itemTmp:SetZOrder(centerWindow[i]:GetZOrder() + 1);
						itemTmp:SetBackground(tonumber(SharedStorageVault[tostring(i)].Q));
						itemTmp:SetBlendMode( Turbine.UI.BlendMode.Overlay );
						itemTmp:SetVisible( true );
						itemTmp:SetMouseVisible( true );

						itemTmp1 = Turbine.UI.Control();
						itemTmp1:SetParent( centerWindow[i] );
						itemTmp1:SetSize( 32, 32 );
						itemTmp1:SetPosition( 1, 1 );
						itemTmp1:SetZOrder(centerWindow[i]:GetZOrder() + 1);
						itemTmp1:SetBackground(tonumber(SharedStorageVault[tostring(i)].B));
						itemTmp1:SetBlendMode( Turbine.UI.BlendMode.Overlay );
						itemTmp1:SetVisible( true );

						itemTmp3 = Turbine.UI.Control();
						itemTmp3:SetParent( centerWindow[i] );
						itemTmp3:SetSize( 32, 32 );
						itemTmp3:SetPosition( 1, 1 );
						itemTmp3:SetZOrder(centerWindow[i]:GetZOrder() + 1);
						if(tonumber(SharedStorageVault[tostring(i)].S) == 0)then
							if(tonumber(SharedStorageVault[tostring(i)].QA) == 1)then
								itemTmp3:SetBackground(0x410030C4);
							end
							if(tonumber(SharedStorageVault[tostring(i)].QA) == 2)then
								itemTmp3:SetBackground(0x410030C4);
							end
							if(tonumber(SharedStorageVault[tostring(i)].QA) == 3)then
								itemTmp3:SetBackground(0x410030C4);
							end
							if(tonumber(SharedStorageVault[tostring(i)].QA) == 4)then
								itemTmp3:SetBackground(0x410030C4);
							end
							if(tonumber(SharedStorageVault[tostring(i)].QA) == 5)then
								itemTmp3:SetBackground(0x410030C4);
							end
						else
							itemTmp3:SetBackground(tonumber(SharedStorageVault[tostring(i)].S));
						end
						itemTmp3:SetBlendMode( Turbine.UI.BlendMode.Overlay );
						itemTmp3:SetVisible( true );

						itemTmp4 = Turbine.UI.Control();
						itemTmp4:SetParent( centerWindow[i] );
						itemTmp4:SetSize( 32, 32 );
						itemTmp4:SetPosition( 1, 1 );
						itemTmp4:SetZOrder(centerWindow[i]:GetZOrder() + 1);
						itemTmp4:SetBackground(tonumber(SharedStorageVault[tostring(i)].I));
						itemTmp4:SetBlendMode( Turbine.UI.BlendMode.Overlay );
						itemTmp4:SetVisible( true );

						UIShowSearch.Message=Turbine.UI.Label(); 
						UIShowSearch.Message:SetParent(centerWindowName[i]); 
						UIShowSearch.Message:SetSize(300, 32); 
						UIShowSearch.Message:SetPosition( 1, 1); 
						UIShowSearch.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft); 
						UIShowSearch.Message:SetText(rgb["gold"] .. SharedStorageVault[tostring(i)].QUA .. rgb["clear"] .. " " .. SharedStorageVault[tostring(i)].N); 
						UIShowSearch.Message:SetBackColor(Turbine.UI.Color( 0.9, 0.3, 0.3, 0.3 ));
						UIShowSearch.Message:SetMarkupEnabled(true);	

						posy = posy + 38;
					end
				end
			nameDisplayed = false;
		end
	end

	if(heightSizeOfMap >= 450)then
		------------------------------------------------------------------------------------------
		-- create the vertical scrollbar for our viewport
		------------------------------------------------------------------------------------------
		vscroll1=Turbine.UI.Lotro.ScrollBar();
		vscroll1:SetParent(UIShowSearch);
		vscroll1:SetOrientation(Turbine.UI.Orientation.Vertical);
		vscroll1:SetPosition(windowWidth-20, 170);
		vscroll1:SetSize(12,viewport1:GetHeight()); -- set width to 12 since it's a "Lotro" style scrollbar and the height is set to match the control that we will be scrolling
		vscroll1:SetBackColor(Turbine.UI.Color(.1,.1,.2)); -- just to give it a little style
		vscroll1:SetMinimum(0);
		vscroll1:SetMaximum(viewport1.map:GetHeight()-viewport1:GetHeight()); -- we will allow scrolling the height of the map-the viewport height
		vscroll1:SetValue(0); -- set the initial value
		------------------------------------------------------------------------------------------
		-- set the ValueChanged event handler to take an action when our value changes, in this case, change the map position relative to the viewport
		------------------------------------------------------------------------------------------
		vscroll1.ValueChanged=function()
			viewport1.map:SetTop(0-vscroll1:GetValue());
		end
	end

	UIShowSearch.Message=Turbine.UI.Label(); 
	UIShowSearch.Message:SetParent(UIShowSearch); 
	UIShowSearch.Message:SetSize(200,40); 
	UIShowSearch.Message:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19);
	UIShowSearch.Message:SetPosition(UIShowSearch:GetWidth()/2 - 100, UIShowSearch:GetHeight() - 85); 
	UIShowSearch.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
	if(textToSearch ~= nil)then
		UIShowSearch.Message:SetText(Strings.PluginSearch1 .. tostring(tmpItemsCount) .. " " .. Strings.PluginSearch6); 
	end
	UIShowSearch:SetZOrder(10);
	UIShowSearch:SetWantsKeyEvents(true);
	UIShowSearch:SetVisible(false);

	ClosingTheWindowSearch();

	UIShowSearch.KeyDown=function(sender, args)
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			UIShowSearch:SetVisible(false);
			settings["isSearchWindowVisible"]["isSearchWindowVisible"] = false;
		end
	
		-- https://www.lotro.com/forums/showthread.php?493466-How-to-hide-a-window-on-F12&p=6581962#post6581962
		if ( args.Action == 268435635 ) then
			hudVisible=not hudVisible;
			if hudVisible then
				UIShowSearch:SetVisible(false);
				MainMinimizedIcon:SetVisible(false);
			else
				UIShowSearch:SetVisible(settings.isSearchWindowVisible);
				MainMinimizedIcon:SetVisible(true);
			end
		end
	end
end
function ReturnNbrItemsInBag(textToSearch)
	local nbrItems = 0;
	local nbrPlayer = 0;
	local playerCount = false;

		if(textToSearch == nil)then
		-- do nothing
		else
			for namePlayerToshow in pairs(PlayerBags) do
				for i in pairs(PlayerBags[namePlayerToshow]) do
					if(string.find(PlayerBags[namePlayerToshow][i].N, textToSearch) ~= nil)then
						nbrItems = nbrItems + 1;
						if(playerCount == false)then
							nbrPlayer = nbrPlayer + 1;
							playerCount = true;
						end
					end
				end
				playerCount = false;
			end
		end
	return nbrItems, nbrPlayer;
end
function ReturnNbrItemsInVault(textToSearch)
	local nbrItems = 0;
	local nbrPlayer = 0;
	local playerCount = false;
	
	if(textToSearch == nil)then
		-- do nothing
		else
			for namePlayerToshow in pairs(PlayerVault) do
				for i in pairs(PlayerVault[namePlayerToshow]) do
					if(string.find(PlayerVault[namePlayerToshow][i].N, textToSearch) ~= nil)then
						nbrItems = nbrItems + 1;
						if(playerCount == false)then
							nbrPlayer = nbrPlayer + 1;
							playerCount = true;
						end
					end
				end
				playerCount = false;
			end
		end
	return nbrItems, nbrPlayer;
end
function ReturnNbrItemsInWallet(textToSearch)
	local nbrItems = 0;
	local nbrPlayer = 0;
	local playerCount = false;
	
	if(textToSearch == nil)then
		-- do nothing
		else
			for namePlayerToshow in pairs(PlayerWallet) do
				for i in pairs(PlayerWallet[namePlayerToshow]) do
					if(string.find(PlayerWallet[namePlayerToshow][i].N, textToSearch) ~= nil)then
						nbrItems = nbrItems + 1;
						if(playerCount == false)then
							nbrPlayer = nbrPlayer + 1;
							playerCount = true;
						end
					end
				end
				playerCount = false;
			end
		end
	return nbrItems, nbrPlayer;
end
function ReturnNbrItemsInSharedStorage(textToSearch)
	local nbrItems = 0;
	local nbrPlayer = 0;

		local nbrItemInSharedSrorage = 0;

		for i in pairs(SharedStorageVault) do
				nbrItemInSharedSrorage = nbrItemInSharedSrorage + 1 ;
		end

		if(textToSearch == nil)then
		-- do nothing
		else
			for i=1, nbrItemInSharedSrorage do  
				if(string.find(SharedStorageVault[tostring(i)].N, textToSearch) ~= nil)then
					nbrItems = nbrItems + 1;
				end
			end
		end
	return nbrItems, nbrPlayer;
end